﻿-- Author      : Nogarder
-- Create Date : 2013/4/29 17:04:26

-- Author      : Nogarder
-- Create Date : 2013/4/29 17:01:54
NPA_Options.RegisterPageFunc("ProfileInporter",function()
	local pairs=pairs
	local table_insert=table.insert
	--localization
	local Localization=NPA_Options.Localization.PagesMainProfileManager
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	local SelectedEntry={}
	--
	local main=NPA_Options.Template.CreateFrameWithBar(parent,Localization["Inport"],610,610,nil,nil,nil)
	main:Hide()
	--
	local page=main.Frame
	local scroll=main.Scroll
	local SettingList={}
	--
	local editbox=NPA_Options.Template.CreateMultiLineEditBox(page,600,200)
	editbox.Scroll:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	editbox:SetMaxLetters(65535)
	NPA_Options.Template.SetTooltips(Localization["PasteTextHere"],editbox,nil,nil,editbox)
	--inport button
	local inportbutton=NPA_Options.Template.CreateButton(page,600,15,Localization["Inport"])
	inportbutton:SetPoint("TOPLEFT",editbox,"BOTTOMLEFT",0,-30)
	--
	local checkboxlist=NPA_Options.Template.CreateCheckBoxList(page,580,120)
	checkboxlist.Scroll:SetPoint("TOPLEFT",inportbutton,"BOTTOMLEFT",0,-5)
	--
	local savetobutton=NPA_Options.Template.CreateButton(page,600,15,Localization["SaveTo"])
	savetobutton:SetPoint("TOPLEFT",checkboxlist.Scroll,"BOTTOMLEFT",0,-50)

	local selectlist=NPA_Options.Template.CreateSelectList(page,580,140)
	selectlist:SetPoint("TOPLEFT",savetobutton,"BOTTOMLEFT",0,-5)
	selectlist.Frame:EnableMouse(false)
	selectlist:EnableMouse(false)
	--
	local CheckSubEntry=function(entry)
		if(type(entry)=="table")then
			local count=0
			local outputa,outputb
			for a,b in pairs(entry)do
				count=count+1
				outputa=a
				outputb=b
			end
			if(count~=1)then
				return nil
			end
			return outputa,outputb
		end
		return nil
	end
	--
	inportbutton:HookScript("OnMouseUp",function()
		local settings=string.gsub(NPA_Options.SettingTranslator.InportProfile(editbox:GetText())," ","")
		--
		SettingList={}
		--
		local data={}
		for index,setting in pairs(settings)do
			local dname=""
			local entry=setting
			local a,b=CheckSubEntry(entry)
			while(a)do
				dname=dname.."\\"..a
				entry=b
				a,b=CheckSubEntry(entry)
			end
			data[dname]=true
			SettingList[dname]=setting
		end
		NPA_Options.Template.UpdateCheckBoxList(checkboxlist,data)
	end)
	--
	selectlist.ButtonClickFunc=function()
		NPA_Options.Template.EnableButton(savetobutton)
	end
	--
	savetobutton:HookScript("OnMouseUp",function()
		local msgbox=NPA_Options.Template.SetMsgBox(page,Localization["ConfirmOverwritten"],function()
			local setting
			if(selectlist.Value=="TheCurrentProfile")then
				setting=NPA_Setting
			else
				setting=NPA_Profile[selectlist.Value]
			end
			--
			local comparelist={}
			--
			local saved=0
			--
			for dname,dsetting in pairs(SettingList)do
				if(checkboxlist.Value[dname]==true)then
					--import
					table.insert(comparelist,{EntryA=setting,EntryB=dsetting})
					saved=saved+1
				end
			end
			--insert setting
			while(next(comparelist))do
				for index,cdata in pairs(comparelist)do
					local EntryA=cdata.EntryA
					local EntryB=cdata.EntryB
					--for every thing in entry b, set it in entry a
					if(type(EntryA)~=type(EntryB))then
						if(type(EntryB)=="table")then
							EntryA=CopyTable(EntryB)
						else
							EntryA=EntryB
						end			
					elseif(type(EntryB)=="table")then
						for bname,bentry in pairs(EntryB)do
							if(EntryA[bname]==nil)then
								if(EntryA[tonumber(bname)]~=nil)then
									table.insert(comparelist,{EntryA=EntryA[tonumber(bname)],EntryB=bentry})
								else
									if(type(bentry)=="table")then
										EntryA[bname]=CopyTable(bentry)
									else
										EntryA[bname]=bentry
									end
								end
							else
								table.insert(comparelist,{EntryA=EntryA[bname],EntryB=bentry})
							end
						end
					else
						if(type(EntryB)=="table")then
							EntryA=CopyTable(EntryB)
						else
							EntryA=EntryB
						end
					end
					--
					comparelist[index]=nil
				end
			end
			print(saved..Localization["Inported"])
			NPA.SettingManager.CheckSettingEntry(setting)
		end)
		msgbox:SetPoint("BOTTOM",savetobutton,"TOP",0,0)
	end)
	--
	main.OnSetFunc=function()
		local data={}
		for name,_ in pairs(NPA_Profile)do
			table.insert(data,{Text=name,Value=name})
		end
		table.insert(data,{Text=Localization["Current"],Value="TheCurrentProfile"})
		--
		NPA_Options.Template.UpdateSelectList(selectlist,data)
		--
		NPA_Options.Template.SetSelectListFocus(selectlist,nil)
		--
		NPA_Options.Template.UpdateCheckBoxList(checkboxlist,{})
		--
		NPA_Options.Template.DisableButton(savetobutton)
		--
		editbox:SetText("")
	end
	--
	NPA_Options.RegisterPage("ProfileInporter",main)
end)